drama.shaders = {};
drama.shaders["swirl"] = {
	src: "#ifdef GL_FRAGMENT_PRECISION_HIGH\n#define highmedp highp\n#else\n#define highmedp mediump\n#endif\n\nvarying mediump vec2 vTex;\nuniform lowp sampler2D samplerFront;\nuniform mediump vec2 srcOriginStart;\nuniform mediump vec2 srcOriginEnd;\n\nuniform mediump float radius;\nuniform mediump float angle;\n\nvoid main(void)\n{\n	mediump vec2 center = vec2(0.5, 0.5);	highmedp vec2 srcOriginSize = srcOriginEnd - srcOriginStart;\n	highmedp vec2 tex = ((vTex - srcOriginStart) / srcOriginSize);\n	\n	highmedp float dist = distance(center, tex);\n	tex -= center;\n	\n	if (dist < radius)\n	{\n		highmedp float percent = (radius - dist) / radius;\n		highmedp float theta = percent * percent * angle * 8.0;\n		highmedp float s = sin(theta);\n		highmedp float c = cos(theta);\n		tex = vec2(dot(tex, vec2(c, -s)), dot(tex, vec2(s, c)));\n	}\n	\n	tex += center;\n	tex = clamp(tex, 0.0, 1.0);	tex = (tex * srcOriginSize) + srcOriginStart;\n	gl_FragColor = texture2D(samplerFront, tex);\n}\n",
	extendBoxHorizontal: 0,
	extendBoxVertical: 0,
	crossSampling: false,
	preservesOpaqueness: false,
	animated: false,
	parameters: [["radius",0,1],["angle",0,1]]
};

drama.shaders["warpripple"] = {
	src: "varying mediump vec2 vTex;\nuniform lowp sampler2D samplerFront;\nuniform mediump vec2 srcOriginStart;\nuniform mediump vec2 srcOriginEnd;\nuniform mediump float seconds;\nuniform mediump vec2 pixelSize;\n\nuniform mediump float freq;\nuniform mediump float amp;\nuniform mediump float speed;\n\nconst mediump float PI = 3.1415926;\n\nvoid main(void)\n{\n	mediump vec2 srcOriginSize = srcOriginEnd - srcOriginStart;\n	mediump vec2 tex = (vTex - srcOriginStart) / srcOriginSize;\n	tex = tex * 2.0 - 1.0;\n		\n	mediump float d = length(tex);\n	mediump float a = atan(tex.y, tex.x);\n	\n	d += sin((d * 2.0 * PI) * freq / (pixelSize.x * 750.0) + (seconds * speed)) * amp * (pixelSize.x * 750.0);\n	\n	tex.x = cos(a) * d;\n	tex.y = sin(a) * d;\n	\n	tex = (tex + 1.0) / 2.0;\n	tex = clamp(tex, 0.0, 1.0);\n	tex = tex * srcOriginSize + srcOriginStart;\n	\n	gl_FragColor = texture2D(samplerFront, tex);\n}\n",
	extendBoxHorizontal: 50,
	extendBoxVertical: 50,
	crossSampling: false,
	preservesOpaqueness: false,
	animated: true,
	parameters: [["freq",0,0],["amp",0,1],["speed",0,0]]
};
